#!/usr/bin/perl
#
# master.cgi -- example control script for Insider clients
#
##################################################################

# Client directory
$basedir = "/var/www/html/clients/";

# Alias file
$alias = "/var/www/html/clients/alias.txt";

# Alert time
# If the client is silent after this period of seconds, print
# the time as red in client table.
$alert = 180;

##################################################################

use CGI qw(:standard);

# Date
$epoch = time;

# If $basedir doesn't exist, create one
if (! -d $basedir) {
        mkdir $basedir;
}


# Build alias file, if exists
if (open(FILE, "<", $alias)) {
        while (<FILE>) {
                chomp;
                # Skip comments and empty lines
                next if (/^#|^$/);
                ($md5, $name) = split(":", $_, 2);
		$aliastable{$md5} = $name;
        }
        close (FILE);
}

print header;
print start_html('The Insider Master cgi');

#
# Print some common web stuff
#

print <<'__EOF_MARKER__';
<center>
<h1>Master cgi</h1>
</center>
__EOF_MARKER__

#
# Print the client web page if invoked with client= parameter
# in URL
#
if (param('client')) {
	print <<'__EOF_MARKER__';
<center>
<a href=/cgi-bin/master.cgi>Back to client index</a>
<hr noshade size=1>
</center>
__EOF_MARKER__
	# Print friendly name for client
	if (exists($aliastable{param('client')})) {
		print "<h2>" . $aliastable{param('client')} . "</h2>";
	} else {
		print "<h2>Client information</h2>";
	}

	# Print the client info file
	$file = $basedir . param('client') . "/info";
	if (open(FILE, $file)) {
		while (<FILE>) {
			chomp;
			print $_ . "<br>";
		}
		close(FILE);
	}

	# Delete requested file before showing the file list
	if (param('del')) {
		$file =  $basedir . param('client') . "/files/" . param('del');
		unlink ($file);
	}
        $dir = $basedir . param('client') . "/files";
	if (opendir(DIR, $dir)) {	
		@files = readdir (DIR);
		@files = grep {!/^\./} @files;
		if ($files[0]) {
			print "<p><hr noshade size=1>\n";
			print "<h2>Downloaded files</h2>\n";
			print "<table width=50%>\n";
			foreach $name (@files) {
				# Print the table
				print "<tr>\n";
				print "<td align=left>\n";
				print "<a href=/clients/" .  param('client') .  "/files/" .  $name . ">" .  $name . "</a>\n";
				print "</td>\n";
				print "<form action=\"/cgi-bin/master.cgi\" method=\"GET\">\n";
				print '<input type=hidden name="client" value="' . param('client') . "\">\n";
				print '<input type=hidden name="del" value="' . $name . "\">\n";
				print "<td><input type=\"submit\" " . "value=\"Delete\"></td>\n";
				print "</form>\n";
				print "</tr>\n";
			}
			print "</table>\n";
		}
	}
	print "<hr noshade size=1>";

	if (param('cmd')) {
		$file = $basedir . param('client') . "/cmd";
		if (open(FILE, ">", $file)) {
			print FILE param('cmd');
			print FILE "\n";
			close(FILE);
		}
	}

	print '<form action="/cgi-bin/master.cgi" method="GET">';
	print "\n";
	print '<input type=hidden name="client" value="' .  param('client') . '">';
	print "\n";
	print '<h2>Pending command</h2>';
	print "\n";
	$file = $basedir . param('client') . "/cmd";
	print '<input type=text size=36 name="cmd" value="';
	if (open(FILE, $file)) {
		while (<FILE>) {
			chomp;
			print $_;
		}
		close(FILE);
	}
	print '">';
print <<'__EOF_MARKER__';

<input type="submit" value="Set new">
</form>
<p>
<table cellpadding=3>
<tr>
<td align=left>
<h2>Results from last command</h2>
</td>
<td>
<form action="/cgi-bin/master.cgi" method="GET">
__EOF_MARKER__
print '<input type=hidden name="client" value="' .  param('client') . '">';
print <<'__EOF_MARKER__';
<input type="submit" value="Refresh">
</form>
</td>
</tr>
</table>
<table width=650>
<tr>
<td bgcolor=#000000>
<font color=#DDDDDD>
<pre>

__EOF_MARKER__
	$file = $basedir . param('client') . "/result";
	if (open(FILE, $file)) {
		while (<FILE>) {
			$line = $_;
			$line =~ s/</&lt;/;
			$line =~ s/>/&gt;/;
			print $line;
		}
		close(FILE);
	}
print <<'__EOF_MARKER__';
</pre>
</td>
</font>
</tr>
</table>
<p>
<hr noshade size=1>
<center>
<a href=/cgi-bin/master.cgi>Back to client index</a>
</center>
__EOF_MARKER__

#
# Print the client table if no client parameter in URL
#
} else {
	print <<'__EOF_MARKER__';
<h2>Available clients</h2>
<table width=100% border=1>
<tr>
<td align=middle><b>ID</b></td>
<td align=middle><b>Last connection</b></td>
<td align=left><b>Information</b></td>
</tr>
__EOF_MARKER__
        $dir = $basedir;
	if (opendir(DIR, $dir)) {	
		@files = readdir (DIR);
		@files = grep {!/^\./} @files;
		foreach $name (@files) {
			# Check for info file
			$file = $dir . $name . "/info";

			# Must exist
			next if (! -e $file);

			# Print the table
			print "<tr>\n";
			print "<td align=middle>\n";
			if (exists($aliastable{$name})) {
				print "<a href=/cgi-bin/master.cgi?client=" . $name . ">" . $aliastable{$name} . "</a>\n";
			} else {
				print "<a href=/cgi-bin/master.cgi?client=" . $name . ">New client</a>\n";
			}
			print "</td>\n";

			# Print the times
			print "<td align=middle>\n";
			$timefile = $dir . $name . "/time";
			if (open(FILE, $timefile)) {
				$lasttime = <FILE>;
				chomp $lasttime;
				$times = $epoch - $lasttime;
				if ($times <= $alert) {
					print "<font color=green>";
				} else {
					print "<font color=red>";
				}
				$seconds = $times % 60;
				$minutes = int($times / 60) % 60;
				$hours = int($times / (60 * 60)) % 24;
				$days = int($times / (60 * 60 * 24));
				print $days . "d " . $hours . "h " . $minutes . "m " . $seconds . "s";
			} else {
				print "<font color=red>";
				print "Unavailable";
			}
			print "</font></td>\n";

			# Print info file
			print "<td>\n";
			if (open(FILE, $file)) {
				while (<FILE>) {
					chomp;
					print $_ . "<br>";
				}
				close(FILE);
			}
			print "</td>\n</tr>\n";
		}
		closedir(DIR);
		print "</table>\n";
	}
}

print end_html;

